package com.ruoyi.project.business.controller.quotation;

import com.ruoyi.project.business.domain.TqSpecificationSurcharge;
import com.ruoyi.project.business.domain.bo.quotation.AdditionFeeAddBO;
import java.util.List;
import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;

import com.ruoyi.project.business.domain.dto.TqSpecificationSurchargeDto;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import com.ruoyi.framework.aspectj.lang.annotation.Log;
import com.ruoyi.framework.aspectj.lang.enums.BusinessType;
import com.ruoyi.project.business.domain.TqAdditionalFees;
import com.ruoyi.project.business.service.quotation.ITqAdditionalFeesService;
import com.ruoyi.framework.web.controller.BaseController;
import com.ruoyi.framework.web.domain.AjaxResult;
import com.ruoyi.common.utils.poi.ExcelUtil;
import com.ruoyi.framework.web.page.TableDataInfo;

/**
 * 【请填写功能名称】Controller
 *
 * @author ruoyi
 * @date 2024-05-16
 */
@RestController
@RequestMapping("/business/additional/fees")
public class TqAdditionalFeesController extends BaseController {

    @Resource
    private ITqAdditionalFeesService tqAdditionalFeesService;

    /**
     * 查询【请填写功能名称】列表
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:list')")
    @GetMapping("/list")
    public TableDataInfo list(TqAdditionalFees tqAdditionalFees) {
        startPage();
        List<TqAdditionalFees> list = tqAdditionalFeesService.selectTqAdditionalFeesList(tqAdditionalFees);
        return getDataTable(list);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:edit')")
    @Log(title = "【查询附加费用】", businessType = BusinessType.UPDATE)
    @GetMapping("/listByQuotationId/{quotationId}")
    public TableDataInfo listByQuotationId(@PathVariable("quotationId") Long quotationId) {
        List<TqAdditionalFees> list = tqAdditionalFeesService.listByQuotationId(quotationId);
        return getDataTable(list);
    }

    /**
     * @Author renzx
     * @Date 2024/8/9
     * @Description 查询附加费用new
     **/
    // @PreAuthorize("@ss.hasPermi('system:fees:edit')")
    @Log(title = "【查询附加费用new】", businessType = BusinessType.UPDATE)
    @GetMapping("/listByQuotationIdNew/{quotationId}")
    public TableDataInfo listByQuotationIdNew(@PathVariable("quotationId") Long quotationId) {
        List<TqSpecificationSurchargeDto> list = tqAdditionalFeesService.listByQuotationIdNew(quotationId);
        return getDataTable(list);
    }

    // @PreAuthorize("@ss.hasPermi('system:fees:edit')")
    @Log(title = "【编辑附加费用】", businessType = BusinessType.UPDATE)
    @PostMapping("/batchAdd")
    public AjaxResult batchAdd(@RequestBody AdditionFeeAddBO addBO) {
        tqAdditionalFeesService.batchAdd(addBO);
        return success();
    }

    @Log(title = "【编辑附加费用】", businessType = BusinessType.UPDATE)
    @PostMapping("/batchAddNew")
    public AjaxResult batchAddNew(@RequestBody List<TqSpecificationSurcharge> tqSpecificationSurcharges) {
        tqAdditionalFeesService.batchAddNew(tqSpecificationSurcharges);
        return success();
    }

    /**
     * 导出【请填写功能名称】列表
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:export')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.EXPORT)
    @PostMapping("/export")
    public void export(HttpServletResponse response, TqAdditionalFees tqAdditionalFees) {
        List<TqAdditionalFees> list = tqAdditionalFeesService.selectTqAdditionalFeesList(tqAdditionalFees);
        ExcelUtil<TqAdditionalFees> util = new ExcelUtil<TqAdditionalFees>(TqAdditionalFees.class);
        util.exportExcel(response, list, "【请填写功能名称】数据");
    }

    /**
     * 获取【请填写功能名称】详细信息
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:query')")
    @GetMapping(value = "/{id}")
    public AjaxResult getInfo(@PathVariable("id") Long id) {
        return success(tqAdditionalFeesService.selectTqAdditionalFeesById(id));
    }

    /**
     * 新增【请填写功能名称】
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:add')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.INSERT)
    @PostMapping
    public AjaxResult add(@RequestBody TqAdditionalFees tqAdditionalFees) {
        return toAjax(tqAdditionalFeesService.insertTqAdditionalFees(tqAdditionalFees));
    }

    /**
     * 修改【请填写功能名称】
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:edit')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.UPDATE)
    @PutMapping
    public AjaxResult edit(@RequestBody TqAdditionalFees tqAdditionalFees) {
        return toAjax(tqAdditionalFeesService.updateTqAdditionalFees(tqAdditionalFees));
    }

    /**
     * 删除【请填写功能名称】
     */
    // @PreAuthorize("@ss.hasPermi('system:fees:remove')")
    @Log(title = "【请填写功能名称】", businessType = BusinessType.DELETE)
    @DeleteMapping("/{ids}")
    public AjaxResult remove(@PathVariable Long[] ids) {
        return toAjax(tqAdditionalFeesService.deleteTqAdditionalFeesByIds(ids));
    }
}
